{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
osCommerce Product Manager for Windows (oscpmwin).
Copyright 2003-2006 by Mario A. Valdez-Ramirez.

You can contact Mario A. Valdez-Ramirez
by email at mario@mariovaldez.org or paper mail at
Olmos 809, San Nicolas, NL. 66495, Mexico.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
unit config;

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin, ExtCtrls, ComCtrls, FR_DSet,
  FR_Desgn, FR_Class;

type
  Topm_Form_Config = class(TForm)
    opm_BitBtn_ConfigOk: TBitBtn;
    opm_BitBtn_ConfigCancel: TBitBtn;
    opm_PageControl_Config: TPageControl;
    opm_TabSheet_ConfigGeneral: TTabSheet;
    opm_TabSheet_ConfigUI: TTabSheet;
    opm_GroupBox_inter: TGroupBox;
    Bevel4: TBevel;
    opm_CheckBox_ConfigRemember: TCheckBox;
    opm_CheckBox_ConfigHotTrack: TCheckBox;
    opm_CheckBox_ConfigAutoload: TCheckBox;
    opm_CheckBox_ConfigDragDrop: TCheckBox;
    opm_CheckBox_ConfigTooltips: TCheckBox;
    opm_CheckBox_ConfigSilent: TCheckBox;
    opm_TabSheet_ConfigImg: TTabSheet;
    opm_GroupBox_ImgConv: TGroupBox;
    opm_CheckBox_ConfigResizeImg: TCheckBox;
    opm_Label_ConfigImgResize: TLabel;
    opm_SpinEdit_ConfigImgX: TSpinEdit;
    opm_SpinEdit_ConfigImgY: TSpinEdit;
    opm_Label_ConfigImgXSymbol: TLabel;
    opm_SpinEdit_ConfigImgQ: TSpinEdit;
    opm_Label_ConfigImgJPEGQuality: TLabel;
    opm_OpenDialog_ConfigINI: TOpenDialog;
    opm_SaveDialog_ConfigINI: TSaveDialog;
    opm_GroupBox_inter2: TGroupBox;
    opm_BitBtn_ConfigReset: TBitBtn;
    Bevel2: TBevel;
    opm_CheckBox_ConfigDragUps: TCheckBox;
    opm_CheckBox_ConfigConfirmDels: TCheckBox;
    opm_CheckBox_ConfigConfirmDrag: TCheckBox;
    opm_CheckBox_ConfigConfirmMods: TCheckBox;
    opm_CheckBox_ConfigConfirmUps: TCheckBox;
    opm_CheckBox_ConfigAutoDownImg: TCheckBox;
    opm_CheckBox_ConfigNoCacheImg: TCheckBox;
    Bevel1: TBevel;
    opm_CheckBox_ConfigConfirmExit: TCheckBox;
    opm_CheckBox_ConfigConfirmImgDels: TCheckBox;
    opm_Label_ConfigJPEGQCategory: TLabel;
    opm_TabSheet_ConfigMods: TTabSheet;
    opm_CheckBox_ConfigPaddingImg: TCheckBox;
    opm_CheckBox_ConfigKeepARImg: TCheckBox;
    opm_BitBtn_ConfigColSel: TBitBtn;
    opm_Panel_ConfigColSel: TPanel;
    opm_GroupBox_INI: TGroupBox;
    opm_BitBtn_ConfigLoadINI: TBitBtn;
    opm_BitBtn_ConfigSaveINI: TBitBtn;
    opm_TabSheet_ConfigUI2: TTabSheet;
    opm_GroupBox_Lang: TGroupBox;
    opm_Label_ConfigUILang: TLabel;
    opm_ComboBox_ConfigUILang: TComboBox;
    opm_Label_ConfigUILangDesc: TLabel;
    Bevel3: TBevel;
    opm_FontDialog_Config: TFontDialog;
    opm_GroupBox_Font: TGroupBox;
    opm_BitBtn_ConfigFont: TBitBtn;
    opm_Label_ConfigFontDetails: TLabel;
    opm_CheckBox_ConfigAllowZeroPrice: TCheckBox;
    opm_CheckBox_ConfigWBDebug: TCheckBox;
    opm_CheckBox_ConfigAllowNegativeQuantity: TCheckBox;
    opm_TabSheet_ConfigReports: TTabSheet;
    opm_GroupBox_Reports: TGroupBox;
    opm_GroupBox_Clipboard: TGroupBox;
    opm_Label_Config_ClipMaxChars: TLabel;
    opm_SpinEdit_Config_ClipColSize: TSpinEdit;
    opm_BitBtn_ConfigReportEdit: TBitBtn;
    opm_ListBox_ConfigReports: TListBox;
    opm_CheckBox_ConfigPRNDirectPrint: TCheckBox;
    opm_frReport_Config: TfrReport;
    opm_frDesigner_Config: TfrDesigner;
    opm_frUserDataset_Config: TfrUserDataset;
    opm_BitBtn_ConfigReportPreview: TBitBtn;
    opm_CheckBox_ConfigAllowEditImageName: TCheckBox;
    opm_Label_ConfigModConnWait: TLabel;
    opm_SpinEdit_ConfigModConnWait: TSpinEdit;
    opm_Label_ConfigModConnRetries: TLabel;
    opm_SpinEdit_ConfigModConnRetries: TSpinEdit;
    opm_OpenDialog_ConfigMod: TOpenDialog;
    opm_GroupBox_Modules: TGroupBox;
    opm_BitBtn_ConfigModDel: TBitBtn;
    opm_ListBox_ConfigMods: TListBox;
    opm_BitBtn_ConfigModEdit: TBitBtn;
    opm_BitBtn_ConfigModAdd: TBitBtn;
    opm_TabSheet_ConfigNet: TTabSheet;
    opm_GroupBox_HTTP: TGroupBox;
    opm_Label_ConfigPHost: TLabel;
    opm_Label_ConfigPPort: TLabel;
    opm_ComboBox_ConfigProxyHost: TComboBox;
    opm_SpinEdit_ConfigProxyPort: TSpinEdit;
    opm_BitBtn_ConfigProxyIE: TBitBtn;
    opm_CheckBox_ConfigUseProxy: TCheckBox;
    opm_ComboBox_ConfigProxyApply: TComboBox;
    opm_GroupBox_HTTPGen: TGroupBox;
    opm_Label_ConfigETABase: TLabel;
    opm_ComboBox_ConfigETABase: TComboBox;
    opm_Label_ConfigUploadURL: TLabel;
    opm_ComboBox_ConfigUploadURL: TComboBox;
    opm_Label_ConfigHTTPConnWait: TLabel;
    opm_SpinEdit_ConfigHTTPConnWait: TSpinEdit;
    opm_GroupBox_Img: TGroupBox;
    opm_ComboBox_ConfigImgURL: TComboBox;
    opm_Label_ConfigImageURL: TLabel;
    opm_CheckBox_ConfigStripes: TCheckBox;
    opm_CheckBox_ConfigCacheIList: TCheckBox;
    opm_Edit_ConfigPDFAuthor: TEdit;
    opm_Label_ConfigPDFAuthor: TLabel;
    opm_ComboBox_ConfigUsername: TComboBox;
    opm_Label_ConfigUsername: TLabel;
    opm_Label_ConfigPassword: TLabel;
    opm_Edit_ConfigPassword: TEdit;
    opm_CheckBox_ConfigStorePass: TCheckBox;
    opm_CheckBox_ConfigDBDebugLog: TCheckBox;
    opm_SpinEdit_ConfigHTTPConnRetries: TSpinEdit;
    opm_Label_ConfigHTTPConnRetries: TLabel;
    opm_CheckBox_ConfigHTTPCompress: TCheckBox;
    opm_CheckBox_ConfigCenterImage: TCheckBox;
    opm_GroupBox_ImgWatermark: TGroupBox;
    opm_CheckBox_ConfigWatermarkImg: TCheckBox;
    opm_Label_ConfigWatermarkBlend: TLabel;
    opm_SpinEdit_ConfigWatermarkBlend: TSpinEdit;
    opm_Edit_ConfigWatermarkFile: TEdit;
    opm_BitBtn_ConfigWatermarkSelectFile: TBitBtn;
    opm_Label_ConfigWatermarkFile: TLabel;
    procedure FormShow(Sender: TObject);
    procedure opm_BitBtn_ConfigOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure opm_BitBtn_ConfigResetClick(Sender: TObject);
    procedure opm_CheckBox_ConfigResizeImgClick(Sender: TObject);
    procedure opm_BitBtn_ConfigSaveINIClick(Sender: TObject);
    procedure opm_BitBtn_ConfigLoadINIClick(Sender: TObject);
    procedure opm_SpinEdit_ConfigImgQChange(Sender: TObject);
    procedure opm_BitBtn_ConfigModDelClick(Sender: TObject);
    procedure opm_ListBox_ConfigModsClick(Sender: TObject);
    procedure opm_BitBtn_ConfigColSelClick(Sender: TObject);
    procedure opm_BitBtn_ConfigProxyIEClick(Sender: TObject);
    procedure opm_BitBtn_ConfigFontClick(Sender: TObject);
    procedure opm_CheckBox_ConfigUseProxyClick(Sender: TObject);
    procedure opm_ListBox_ConfigReportsClick(Sender: TObject);
    procedure opm_BitBtn_ConfigReportEditClick(Sender: TObject);
    procedure opm_frReport_ConfigGetValue (const ParName: String; var ParValue: Variant);
    procedure opm_frUserDataset_ConfigCheckEOF(Sender: TObject; var Eof: Boolean);
    procedure opm_BitBtn_ConfigReportPreviewClick(Sender: TObject);
    procedure opm_BitBtn_ConfigModEditClick(Sender: TObject);
    procedure opm_ListBox_ConfigModsDblClick(Sender: TObject);
    procedure opm_ListBox_ConfigReportsDblClick(Sender: TObject);
    procedure opm_BitBtn_ConfigModAddClick(Sender: TObject);
    procedure opm_BitBtn_ConfigWatermarkSelectFileClick(Sender: TObject);
    procedure opm_CheckBox_ConfigWatermarkImgClick(Sender: TObject);
  private
    PROCEDURE PRopm_ControlToVars;
    procedure PRopm_VarsToControls;
    PROCEDURE opm_PRRefresh_ModuleList (LastIndex : INTEGER);
    PROCEDURE opm_PRRefresh_ReportList (LastIndex : INTEGER);
  public
  end;

var
  opm_Form_Config: Topm_Form_Config;

implementation

{$R *.dfm}

Uses gnugettext, oscpmdata, regconfig, attention, imageman, modules, dataman,
     colorsel, network, configmod, openpicdlg;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.PRopm_VarsToControls;
VAR
  UILang : LONGINT;
begin
  opm_Edit_ConfigPDFAuthor.Text := opmG_PDFAuthor;
  opm_ComboBox_ConfigUsername.Text := opmG_DBUsername;
  opm_ComboBox_ConfigImgURL.Text := opmG_WBImgURL;
  opm_ComboBox_ConfigUploadURL.Text := opmG_WBUploadURL;
  opm_ComboBox_ConfigUsername.Items := opmG_PastUsername_BoxList;
  opm_ComboBox_ConfigImgURL.Items := opmG_PastImgURL_BoxList;
  opm_ComboBox_ConfigUploadURL.Items := opmG_PastUploadURL_BoxList;
  opm_ComboBox_ConfigProxyHost.Items := opmG_PastProxy_BoxList;
  opm_ComboBox_ConfigProxyHost.Text := opmG_WBProxyHost;
  opm_Edit_ConfigPassword.Text := opmG_DBPassword;
  opm_ComboBox_ConfigETABase.Text := INTTOSTR (opmG_ETABase) + ' kbps';
  opm_SpinEdit_ConfigProxyPort.Value := opmG_WBProxyPort;
  opm_SpinEdit_ConfigModConnWait.Value := opmG_ModConnWait;
  opm_SpinEdit_ConfigHTTPConnWait.Value := opmG_HTTPConnWait;
  opm_SpinEdit_ConfigModConnRetries.Value := opmG_ModConnRetries;
  opm_SpinEdit_ConfigHTTPConnRetries.Value := opmG_HTTPConnRetries;
  opm_SpinEdit_ConfigImgX.Value := opmG_WBImgX;
  opm_SpinEdit_ConfigImgY.Value := opmG_WBImgY;
  opm_SpinEdit_ConfigImgQ.Value := opmG_WBImgQ;
  opm_Label_ConfigJPEGQCategory.Caption := FNopm_QualityExplain (opmG_WBImgQ);
  opm_Panel_ConfigColSel.Color := FNopm_DecColorToColor (opmG_WBPaddingColor);
  opm_Panel_ConfigColSel.Caption := FNopm_ColorToRGB (opm_Panel_ConfigColSel.Color);
  opm_PageControl_Config.ActivePageIndex := 0;
  opm_CheckBox_ConfigHotTrack.Checked := (opmG_UIHotTracking > 0);
  opm_CheckBox_ConfigRemember.Checked := (opmG_UIRememberDisplay > 0);
  opm_CheckBox_ConfigAutoload.Checked := (opmG_UIClickLoad > 0);
  opm_CheckBox_ConfigDragDrop.Checked := (opmG_UIDragDrop > 0);
  opm_CheckBox_ConfigDragUps.Checked := (opmG_UIImgDragDrop > 0);
  opm_CheckBox_ConfigTooltips.Checked := (opmG_UIToolTips > 0);
  opm_CheckBox_ConfigStripes.Checked := (opmG_UIStripes > 0);
  opm_CheckBox_ConfigCacheIList.Checked := (opmG_UICacheIList > 0);
  opm_CheckBox_ConfigUseProxy.Checked := (opmG_UseProxy > 0);
  opm_ComboBox_ConfigProxyApply.ItemIndex := opmG_ProxyApply;
  opm_CheckBox_ConfigStorePass.Checked := (opmG_DBStorePass > 0);
  opm_CheckBox_ConfigSilent.Checked := (opmG_UISilent > 0);
  opm_CheckBox_ConfigSilent.Enabled := (FNopm_CheckSound = TRUE);
  opm_CheckBox_ConfigConfirmDels.Checked := (opmG_UIConfirmDels > 0);
  opm_CheckBox_ConfigConfirmDrag.Checked := (opmG_UIConfirmDrag > 0);
  opm_CheckBox_ConfigConfirmMods.Checked := (opmG_UIConfirmMods > 0);
  opm_CheckBox_ConfigAllowZeroPrice.Checked := (opmG_UIAllowZeroPrice > 0);
  opm_CheckBox_ConfigAllowEditImageName.Checked := (opmG_UIAllowEditImageName > 0);
  opm_CheckBox_ConfigAllowNegativeQuantity.Checked := (opmG_UIAllowNegativeQuantity > 0);
  opm_CheckBox_ConfigAutoDownImg.Checked := (opmG_UIAutoDownImg > 0);
  opm_FontDialog_Config.Font.Name := opmG_UIFontName;
  opm_FontDialog_Config.Font.Height := opmG_UIFontHeight;
  opm_FontDialog_Config.Font.Charset := opmG_UIFontCharset;
  opm_FontDialog_Config.Font.Style := opmC_DefaultFontStyle;
  opm_Label_ConfigFontDetails.Font := opm_FontDialog_Config.Font;
  opm_Label_ConfigFontDetails.Caption := opmG_UIFontName + ', ' +
                                         INTTOSTR (ROUND ((opmG_UIFontHeight * -72) / opm_FontDialog_Config.Font.PixelsPerInch)) + ', ' +
                                         opmG_CharsetList [opmG_UIFontCharset];
  opm_SpinEdit_Config_ClipColSize.Value := opmG_Clip_ColSize;
  opm_CheckBox_ConfigPRNDirectPrint.Checked := (opmG_PRNDirectPrint > 0);
  opm_CheckBox_ConfigNoCacheImg.Checked := (opmG_WBNoCacheImg > 0);
  opm_CheckBox_ConfigResizeImg.Checked := (opmG_WBResizeImg > 0);
  opm_CheckBox_ConfigWatermarkImg.Checked := (opmG_WBWatermarkImg > 0);
  opm_SpinEdit_ConfigWatermarkBlend.Value := opmG_WBWatermarkBlend;
  opm_Edit_ConfigWatermarkFile.Text := opmG_WBWatermarkFile;
  opm_CheckBox_ConfigPaddingImg.Checked := (opmG_WBPaddingImg > 0);
  opm_CheckBox_ConfigKeepARImg.Checked := (opmG_WBKeepARImg > 0);
  opm_CheckBox_ConfigConfirmExit.Checked := (opmG_UIConfirmExit > 0);
  opm_CheckBox_ConfigCenterImage.Checked := (opmG_UICenterImage > 0);
  opm_CheckBox_ConfigDBDebugLog.Checked := (opmG_DBDebugLog > 0);
  opm_CheckBox_ConfigHTTPCompress.Checked := (opmG_HTTPCompress > 0);
  opm_CheckBox_ConfigWBDebug.Checked := (opmG_UIWBDebug > 0);
  IF (opm_ComboBox_ConfigUILang.Items.Count > 0) THEN
    FOR UILang := 0 TO opm_ComboBox_ConfigUILang.Items.Count DO
      IF (ANSIPOS ('(' + opmG_UIGUILang + ')', opm_ComboBox_ConfigUILang.Items[UILang]) > 0) THEN
        BEGIN
          opm_ComboBox_ConfigUILang.ItemIndex := UILang;
          BREAK;
        END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Config.FormShow(Sender: TObject);
BEGIN
  opm_Form_Config.Caption := _('Settings of ') + opmC_AppShortName;
  opm_ComboBox_ConfigUILang.Items.Clear;
  DefaultInstance.GetListOfLanguages ('default', opm_ComboBox_ConfigUILang.Items);
  opm_ComboBox_ConfigUILang.Sorted := TRUE;
  IF (opm_ComboBox_ConfigUILang.Items.Count > 0) THEN
    BEGIN
      DefaultInstance.BindtextdomainToFile ('isotolanguagenames', ExtractFilePath (Application.Exename) + 'locale/isotolanguagenames.mo');
      DefaultInstance.TranslateProperties (opm_ComboBox_ConfigUILang, 'isotolanguagenames');
      opm_ComboBox_ConfigUILang.Enabled := TRUE;
    END
  ELSE
    opm_ComboBox_ConfigUILang.Enabled := FALSE;
  opm_Label_ConfigUILangDesc.Caption := _('Do you want to contribute with a translation in your native language?') + #13#10 +
                                        _('It is very easy, and you don''t have to be a programmer to do it.') + #13#10 +
                                        _('Please visit the website for more information.');
  PRopm_VarsToControls;
  opm_Label_ConfigImgResize.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_CheckBox_ConfigPaddingImg.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_CheckBox_ConfigKeepARImg.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgX.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgY.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Panel_ConfigColSel.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_BitBtn_ConfigColSel.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgQ.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigImgJPEGQuality.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigJPEGQCategory.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigWatermarkBlend.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_SpinEdit_ConfigWatermarkBlend.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_Edit_ConfigWatermarkFile.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_BitBtn_ConfigWatermarkSelectFile.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_Label_ConfigWatermarkFile.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_ComboBox_ConfigProxyApply.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_ComboBox_ConfigProxyHost.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_SpinEdit_ConfigProxyPort.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_BitBtn_ConfigProxyIE.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Label_ConfigPHost.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Label_ConfigPPort.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_BitBtn_ConfigModDel.Enabled := FALSE;
  opm_BitBtn_ConfigModEdit.Enabled := FALSE;
  opm_PRRefresh_ModuleList (-1);
  opm_ListBox_ConfigMods.ScrollWidth := ROUND (opm_ListBox_ConfigMods.Width * 1.5);
  opm_BitBtn_ConfigReportEdit.Enabled := FALSE;
  opm_BitBtn_ConfigReportPreview.Enabled := FALSE;
  opm_PRRefresh_ReportList (-1);
  opm_ListBox_ConfigReports.ScrollWidth := ROUND (opm_ListBox_ConfigReports.Width * 1.5);
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Config.PRopm_ControlToVars;
VAR
  LangUIStr : STRING;
BEGIN
  opmG_PDFAuthor := TRIM (opm_Edit_ConfigPDFAuthor.Text);
  opmG_DBUsername := TRIM (opm_ComboBox_ConfigUsername.Text);
  opmG_DBPassword := TRIM (opm_Edit_ConfigPassword.Text);
  opmG_WBImgURL := FNopm_FixURL (opm_ComboBox_ConfigImgURL.Text);
  opmG_WBUploadURL := FNopm_FixURL (opm_ComboBox_ConfigUploadURL.Text);
  opmG_WBProxyHost := FNopm_CleanHostName (opm_ComboBox_ConfigProxyHost.Text);
  IF (opmG_WBImgURL[LENGTH (opmG_WBImgURL)] <> '/') THEN opmG_WBImgURL := opmG_WBImgURL + '/';
  opmG_ETABase := FNopm_StrToInt (opm_ComboBox_ConfigETABase.Text);
  opmG_WBProxyPort := ABS (opm_SpinEdit_ConfigProxyPort.Value);
  opmG_ModConnWait := ABS (ROUND ((opm_SpinEdit_ConfigModConnWait.Value + 1) / opmC_MiliSecIncrement) * opmC_MiliSecIncrement);
  opmG_HTTPConnWait := ABS (ROUND ((opm_SpinEdit_ConfigHTTPConnWait.Value + 1) / opmC_MiliSecIncrement) * opmC_MiliSecIncrement);
  opmG_ModConnRetries := ABS (opm_SpinEdit_ConfigModConnRetries.Value);
  opmG_HTTPConnRetries := ABS (opm_SpinEdit_ConfigHTTPConnRetries.Value);
  opmG_WBImgX := ABS (opm_SpinEdit_ConfigImgX.Value);
  opmG_WBImgY := ABS (opm_SpinEdit_ConfigImgY.Value);
  opmG_WBImgQ := ABS (opm_SpinEdit_ConfigImgQ.Value);
  IF (opm_CheckBox_ConfigHotTrack.Checked = TRUE) THEN opmG_UIHotTracking := 1 ELSE opmG_UIHotTracking := 0;
  IF (opm_CheckBox_ConfigRemember.Checked = TRUE) THEN opmG_UIRememberDisplay := 1 ELSE opmG_UIRememberDisplay := 0;
  IF (opm_CheckBox_ConfigAutoload.Checked = TRUE) THEN opmG_UIClickLoad := 1 ELSE opmG_UIClickLoad := 0;
  IF (opm_CheckBox_ConfigDragDrop.Checked = TRUE) THEN opmG_UIDragDrop := 1 ELSE opmG_UIDragDrop := 0;
  IF (opm_CheckBox_ConfigDragUps.Checked = TRUE) THEN opmG_UIImgDragDrop := 1 ELSE opmG_UIImgDragDrop := 0;
  IF (opm_CheckBox_ConfigToolTips.Checked = TRUE) THEN opmG_UIToolTips := 1 ELSE opmG_UIToolTips := 0;
  IF (opm_CheckBox_ConfigStripes.Checked = TRUE) THEN opmG_UIStripes := 1 ELSE opmG_UIStripes := 0;
  IF (opm_CheckBox_ConfigCacheIList.Checked = TRUE) THEN opmG_UICacheIList := 1 ELSE opmG_UICacheIList := 0;
  IF (opm_CheckBox_ConfigUseProxy.Checked = TRUE) THEN opmG_UseProxy := 1 ELSE opmG_UseProxy := 0;
  IF (opm_ComboBox_ConfigProxyApply.ItemIndex >= 0) THEN opmG_ProxyApply := opm_ComboBox_ConfigProxyApply.ItemIndex ELSE opmG_ProxyApply := opmC_Def_ProxyApply; 
  IF (opm_CheckBox_ConfigStorePass.Checked = TRUE) THEN opmG_DBStorePass := 1 ELSE opmG_DBStorePass := 0;
  IF (opm_CheckBox_ConfigSilent.Checked = TRUE) THEN opmG_UISilent := 1 ELSE opmG_UISilent := 0;
  IF (opm_CheckBox_ConfigConfirmDels.Checked = TRUE) THEN opmG_UIConfirmDels := 1 ELSE opmG_UIConfirmDels := 0;
  IF (opm_CheckBox_ConfigConfirmDrag.Checked = TRUE) THEN opmG_UIConfirmDrag := 1 ELSE opmG_UIConfirmDrag := 0;
  IF (opm_CheckBox_ConfigConfirmMods.Checked = TRUE) THEN opmG_UIConfirmMods := 1 ELSE opmG_UIConfirmMods := 0;
  IF (opm_CheckBox_ConfigAllowZeroPrice.Checked = TRUE) THEN opmG_UIAllowZeroPrice := 1 ELSE opmG_UIAllowZeroPrice := 0;
  IF (opm_CheckBox_ConfigAllowEditImageName.Checked = TRUE) THEN opmG_UIAllowEditImageName := 1 ELSE opmG_UIAllowEditImageName := 0;
  IF (opm_CheckBox_ConfigAllowNegativeQuantity.Checked = TRUE) THEN opmG_UIAllowNegativeQuantity := 1 ELSE opmG_UIAllowNegativeQuantity := 0;
  IF (opm_CheckBox_ConfigAutoDownImg.Checked = TRUE) THEN opmG_UIAutoDownImg := 1 ELSE opmG_UIAutoDownImg := 0;
  opmG_UIFontName := opm_FontDialog_Config.Font.Name;
  opmG_UIFontHeight := opm_FontDialog_Config.Font.Height;
  opmG_UIFontCharset := opm_FontDialog_Config.Font.Charset;
  opmG_Clip_ColSize := ABS (opm_SpinEdit_Config_ClipColSize.Value);
  IF (opm_CheckBox_ConfigPRNDirectPrint.Checked = TRUE) THEN opmG_PRNDirectPrint := 1 ELSE opmG_PRNDirectPrint := 0;
  IF (opm_CheckBox_ConfigNoCacheImg.Checked = TRUE) THEN opmG_WBNoCacheImg := 1 ELSE opmG_WBNoCacheImg := 0;
  IF (opm_CheckBox_ConfigResizeImg.Checked = TRUE) THEN opmG_WBResizeImg := 1 ELSE opmG_WBResizeImg := 0;
  IF (opm_CheckBox_ConfigWatermarkImg.Checked = TRUE) THEN opmG_WBWatermarkImg := 1 ELSE opmG_WBWatermarkImg := 0;
  opmG_WBWatermarkBlend := ABS (opm_SpinEdit_ConfigWatermarkBlend.Value);
  opmG_WBWatermarkFile := TRIM (opm_Edit_ConfigWatermarkFile.Text);
  IF (opm_CheckBox_ConfigPaddingImg.Checked = TRUE) THEN opmG_WBPaddingImg := 1 ELSE opmG_WBPaddingImg := 0;
  IF (opm_CheckBox_ConfigKeepARImg.Checked = TRUE) THEN opmG_WBKeepARImg := 1 ELSE opmG_WBKeepARImg := 0;
  IF (opm_CheckBox_ConfigConfirmExit.Checked = TRUE) THEN opmG_UIConfirmExit := 1 ELSE opmG_UIConfirmExit := 0;
  IF (opm_CheckBox_ConfigCenterImage.Checked = TRUE) THEN opmG_UICenterImage := 1 ELSE opmG_UICenterImage := 0;
  IF (opm_CheckBox_ConfigDBDebugLog.Checked = TRUE) THEN opmG_DBDebugLog := 1 ELSE opmG_DBDebugLog := 0;
  IF (opm_CheckBox_ConfigHTTPCompress.Checked = TRUE) THEN opmG_HTTPCompress := 1 ELSE opmG_HTTPCompress := 0;
  IF (opm_CheckBox_ConfigWBDebug.Checked = TRUE) THEN opmG_UIWBDebug := 1 ELSE opmG_UIWBDebug := 0;
  LangUIStr := opm_ComboBox_ConfigUILang.Items[opm_ComboBox_ConfigUILang.ItemIndex];
  IF (opm_ComboBox_ConfigUILang.Items.Count > 0) THEN
    opmG_UIGUILang := COPY (LangUIStr, ANSIPOS ('(', LangUIStr) + 1, ANSIPOS (')', LangUIStr) - ANSIPOS ('(', LangUIStr) - 1)
  ELSE
    opmG_UIGUILang := opmC_Def_GUILang;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigOkClick(Sender: TObject);
begin
  PRopm_ControlToVars;
  PRReg_WriteSetting ('OSCETABase', INTTOSTR (opmG_ETABase), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCPDFAuthor', opmG_PDFAuthor, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable01', opmG_DBTable_Categories, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable02', opmG_DBTable_Manufacturers, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable03', opmG_DBTable_Languages, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable04', opmG_DBTable_Products, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable05', opmG_DBTable_Specials, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable06', opmG_DBTable_ProductsDescription, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable07', opmG_DBTable_TaxClass, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable08', opmG_DBTable_Currencies, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable09', opmG_DBTable_Configuration, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable10', opmG_DBTable_ProductsToCategories, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable11', opmG_DBTable_CategoriesDescription, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable13', opmG_DBTable_TaxRates, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCTable14', opmG_DBTable_ManufacturersInfo, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCUsername', opmG_DBUsername, opmC_RegistryKey, opmC_RKConfig);
  IF (opmG_DBStorePass > 0) THEN
    PRReg_WriteSetting ('OSCPassword', opmG_DBPassword, opmC_RegistryKey, opmC_RKConfig)
  ELSE
    PRReg_WriteSetting ('OSCPassword', '', opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgURL', opmG_WBImgURL, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCUploadURL', opmG_WBUploadURL, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCProxyHost', opmG_WBProxyHost, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCProxyPort', IntToStr (opmG_WBProxyPort), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCModConnWait', IntToStr (opmG_ModConnWait), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCHTTPConnWait', IntToStr (opmG_HTTPConnWait), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCModConnRetries', IntToStr (opmG_ModConnRetries), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCHTTPConnRetries', IntToStr (opmG_HTTPConnRetries), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgX', IntToStr (opmG_WBImgX), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgY', IntToStr (opmG_WBImgY), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgQ', IntToStr (opmG_WBImgQ), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCPaddingColor', IntToStr (opmG_WBPaddingColor), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCHotTracking', IntToStr (opmG_UIHotTracking), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAutoLoad', IntToStr (opmG_UIClickLoad), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCDragDrop', IntToStr (opmG_UIDragDrop), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCImgDragDrop', IntToStr (opmG_UIImgDragDrop), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCToolTips', IntToStr (opmG_UIToolTips), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCStripes', IntToStr (opmG_UIStripes), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCCacheIList', IntToStr (opmG_UICacheIList), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCUseProxy', IntToStr (opmG_UseProxy), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCProxyApply', IntToStr (opmG_ProxyApply), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCStorePass', IntToStr (opmG_DBStorePass), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCSilent', IntToStr (opmG_UISilent), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCConfirmDels', IntToStr (opmG_UIConfirmDels), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCConfirmDrag', IntToStr (opmG_UIConfirmDrag), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCConfirmMods', IntToStr (opmG_UIConfirmMods), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAllowZeroPrice', IntToStr (opmG_UIAllowZeroPrice), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAllowEditImageName', IntToStr (opmG_UIAllowEditImageName), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAllowNegativeQuantity', IntToStr (opmG_UIAllowNegativeQuantity), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCAutoDownImg', IntToStr (opmG_UIAutoDownImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('UIFontName', opmG_UIFontName, opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('UIFontHeight', INTTOSTR (opmG_UIFontHeight), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('UIFontCharset', INTTOSTR (opmG_UIFontCharset), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('Clip_ColSize', IntToStr (opmG_Clip_ColSize), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PRNDirectPrint', IntToStr (opmG_PRNDirectPrint), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastAvailDate', INTTOSTR (opmG_Past_PAvailDate), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastManufacturer', INTTOSTR (opmG_Past_PManufacturer), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastTaxClass', INTTOSTR (opmG_Past_PTaxClass), opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('PastImageDir', opmG_Past_PImageDir, opmC_RegistryKey, opmC_RKVisual);
  PRReg_WriteSetting ('OSCNoCacheImg', IntToStr (opmG_WBNoCacheImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCResizeImg', IntToStr (opmG_WBResizeImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCWatermarkImg', IntToStr (opmG_WBWatermarkImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCWatermarkBlend', IntToStr (opmG_WBWatermarkBlend), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCWatermarkFile', opmG_WBWatermarkFile, opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCPaddingImg', IntToStr (opmG_WBPaddingImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCKeepARImg', IntToStr (opmG_WBKeepARImg), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCConfirmExit', IntToStr (opmG_UIConfirmExit), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCCenterImage', IntToStr (opmG_UICenterImage), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCDBDebugLog', IntToStr (opmG_DBDebugLog), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCHTTPCompress', IntToStr (opmG_HTTPCompress), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCWBDebug', IntToStr (opmG_UIWBDebug), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WriteSetting ('OSCRememberPosition', IntToStr (opmG_UIRememberDisplay), opmC_RegistryKey, opmC_RKConfig);
  PRReg_WritePastList ('Username', opmC_RegistryKey, opmC_RKServers, opmG_DBUsername, opmG_PastUsername_BoxList, opmC_MaxPast_Usernames);
  PRReg_WritePastList ('ImgURL', opmC_RegistryKey, opmC_RKServers, opmG_WBImgURL, opmG_PastImgURL_BoxList, opmC_MaxPast_ImgURL);
  PRReg_WritePastList ('UploadURL', opmC_RegistryKey, opmC_RKServers, opmG_WBUploadURL, opmG_PastUploadURL_BoxList, opmC_MaxPast_UploadURL);
  PRReg_WritePastList ('Proxy', opmC_RegistryKey, opmC_RKServers, opmG_WBProxyHost, opmG_PastProxy_BoxList, opmC_MaxPast_Proxy);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.FormCreate(Sender: TObject);
begin
  opm_SpinEdit_ConfigProxyPort.MinValue := opmC_Min_ProxyPort;
  opm_SpinEdit_ConfigProxyPort.MaxValue := opmC_Max_ProxyPort;
  opm_SpinEdit_ConfigModConnWait.MinValue := opmC_Min_ModConnWait;
  opm_SpinEdit_ConfigModConnWait.MaxValue := opmC_Max_ModConnWait;
  opm_SpinEdit_ConfigModConnWait.Increment := opmC_MiliSecIncrement;
  opm_SpinEdit_ConfigHTTPConnWait.MinValue := opmC_Min_HTTPConnWait;
  opm_SpinEdit_ConfigHTTPConnWait.MaxValue := opmC_Max_HTTPConnWait;
  opm_SpinEdit_ConfigHTTPConnWait.Increment := opmC_MiliSecIncrement;
  opm_SpinEdit_ConfigModConnRetries.MinValue := opmC_Min_ModConnRetries;
  opm_SpinEdit_ConfigModConnRetries.MaxValue := opmC_Max_ModConnRetries;
  opm_SpinEdit_ConfigHTTPConnRetries.MinValue := opmC_Min_HTTPConnRetries;
  opm_SpinEdit_ConfigHTTPConnRetries.MaxValue := opmC_Max_HTTPConnRetries;
  opm_SpinEdit_ConfigImgX.MinValue := opmC_Min_ImgX;
  opm_SpinEdit_ConfigImgX.MaxValue := opmC_Max_ImgX;
  opm_SpinEdit_ConfigImgY.MinValue := opmC_Min_ImgY;
  opm_SpinEdit_ConfigImgY.MaxValue := opmC_Max_ImgY;
  opm_SpinEdit_ConfigImgQ.MinValue := opmC_Min_ImgQ;
  opm_SpinEdit_ConfigImgQ.MaxValue := opmC_Max_ImgQ;
  opm_SpinEdit_ConfigWatermarkBlend.MinValue := opmC_Min_WatermarkBlend;
  opm_SpinEdit_ConfigWatermarkBlend.MaxValue := opmC_Max_WatermarkBlend;
  opm_ComboBox_ConfigETABase.Items.Text := opmC_ETABitrates;
  opm_ComboBox_ConfigProxyApply.Items.Text := _('For all web connections') + #13#10 + _('For OSCPM script only') + #13#10 + _('To check updates only') + #13#10;
  opm_Edit_ConfigPassword.PasswordChar := opmC_PasswordChar;
  opm_FontDialog_Config.MinFontSize := opmC_Min_FontHeight;
  opm_FontDialog_Config.MaxFontSize := opmC_Max_FontHeight;
  opm_SpinEdit_Config_ClipColSize.MinValue := opmC_Min_Clip_ColSize;
  opm_SpinEdit_Config_ClipColSize.MaxValue := opmC_Max_Clip_ColSize;
  IF (opmG_UIHotTracking > 0) THEN
    opm_PageControl_Config.HotTrack := TRUE
  ELSE
    opm_PageControl_Config.HotTrack := FALSE;
  TranslateComponent (self);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigResetClick(Sender: TObject);
begin
  opm_CheckBox_ConfigHotTrack.Checked := (opmC_Def_HotTracking > 0);
  opm_CheckBox_ConfigRemember.Checked := (opmC_Def_RememberDisplay > 0);
  opm_CheckBox_ConfigAutoload.Checked := (opmC_Def_AutoLoad > 0);
  opm_CheckBox_ConfigDragDrop.Checked := (opmC_Def_DragDrop > 0);
  opm_CheckBox_ConfigDragUps.Checked := (opmC_Def_ImgDragDrop > 0);
  opm_CheckBox_ConfigTooltips.Checked := (opmC_Def_Tooltips > 0);
  opm_CheckBox_ConfigStripes.Checked := (opmC_Def_Stripes > 0);
  opm_CheckBox_ConfigCacheIList.Checked := (opmC_Def_CacheIList > 0);
  opm_CheckBox_ConfigConfirmDels.Checked := (opmC_Def_ConfirmDels > 0);
  opm_CheckBox_ConfigConfirmDrag.Checked := (opmC_Def_ConfirmDrag > 0);
  opm_CheckBox_ConfigConfirmMods.Checked := (opmC_Def_ConfirmMods > 0);
  opm_CheckBox_ConfigAllowZeroPrice.Checked := (opmC_Def_AllowZeroPrice > 0);
  opm_CheckBox_ConfigAllowEditImageName.Checked := (opmC_Def_AllowEditImageName > 0);
  opm_CheckBox_ConfigAllowNegativeQuantity.Checked := (opmC_Def_AllowNegativeQuantity > 0);
  opm_CheckBox_ConfigAutoDownImg.Checked := (opmC_Def_AutoDownImg > 0);
  opm_CheckBox_ConfigNoCacheImg.Checked := (opmC_Def_NoCacheImg > 0);
  opm_CheckBox_ConfigConfirmExit.Checked := (opmC_Def_ConfirmExit > 0);
  opm_CheckBox_ConfigCenterImage.Checked := (opmC_Def_CenterImage > 0);
  opm_CheckBox_ConfigDBDebugLog.Checked := (opmC_Def_DBDebugLog > 0);
  opm_CheckBox_ConfigHTTPCompress.Checked := (opmC_Def_HTTPCompress > 0);
  opm_CheckBox_ConfigWBDebug.Checked := (opmC_Def_WBDebug > 0);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_CheckBox_ConfigResizeImgClick (Sender: TObject);
begin
  opm_Label_ConfigImgResize.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_CheckBox_ConfigPaddingImg.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_CheckBox_ConfigKeepARImg.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgX.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgY.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Panel_ConfigColSel.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_BitBtn_ConfigColSel.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_SpinEdit_ConfigImgQ.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigImgJPEGQuality.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
  opm_Label_ConfigJPEGQCategory.Enabled := opm_CheckBox_ConfigResizeImg.Checked;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigSaveINIClick(Sender: TObject);
begin
  opm_SaveDialog_ConfigINI.DefaultExt := opmC_Def_SaveINIExt;
  opm_SaveDialog_ConfigINI.FileName := opmC_Def_SaveINIFilename;
  opm_SaveDialog_ConfigINI.Filter := _('Configuration files') + ' (' + opmC_Def_SaveINIFilter + ')|' + opmC_Def_SaveINIFilter + '|' + _('All files (*.*)');
  opm_SaveDialog_ConfigINI.Title := _('Saving configuration file...');
  opm_SaveDialog_ConfigINI.InitialDir := ExtractFilePath (Application.Exename);
  IF (opm_SaveDialog_ConfigINI.Execute = TRUE) THEN
    BEGIN
      PRopm_ControlToVars;
      PRINI_WriteSetting ('OSCETABase', INTTOSTR (opmG_ETABase), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCPDFAuthor', opmG_PDFAuthor, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable01', opmG_DBTable_Categories, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable02', opmG_DBTable_Manufacturers, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable03', opmG_DBTable_Languages, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable04', opmG_DBTable_Products, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable05', opmG_DBTable_Specials, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable06', opmG_DBTable_ProductsDescription, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable07', opmG_DBTable_TaxClass, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable08', opmG_DBTable_Currencies, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable09', opmG_DBTable_Configuration, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable10', opmG_DBTable_ProductsToCategories, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable11', opmG_DBTable_CategoriesDescription, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable13', opmG_DBTable_TaxRates, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCTable14', opmG_DBTable_ManufacturersInfo, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCUsername', opmG_DBUsername, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      IF (opmG_DBStorePass > 0) THEN
        PRINI_WriteSetting ('OSCPassword', opmG_DBPassword, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig)
      ELSE
        PRINI_WriteSetting ('OSCPassword', '', opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgURL', opmG_WBImgURL, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCUploadURL', opmG_WBUploadURL, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCProxyHost', opmG_WBProxyHost, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCProxyPort', IntToStr (opmG_WBProxyPort), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCModConnWait', IntToStr (opmG_ModConnWait), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCHTTPConnWait', IntToStr (opmG_HTTPConnWait), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCModConnRetries', IntToStr (opmG_ModConnRetries), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCHTTPConnRetries', IntToStr (opmG_HTTPConnRetries), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgX', IntToStr (opmG_WBImgX), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgY', IntToStr (opmG_WBImgY), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgQ', IntToStr (opmG_WBImgQ), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCPaddingColor', IntToStr (opmG_WBPaddingColor), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCHotTracking', IntToStr (opmG_UIHotTracking), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAutoLoad', IntToStr (opmG_UIClickLoad), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCDragDrop', IntToStr (opmG_UIDragDrop), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCImgDragDrop', IntToStr (opmG_UIImgDragDrop), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCToolTips', IntToStr (opmG_UIToolTips), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCStripes', IntToStr (opmG_UIStripes), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCCacheIList', IntToStr (opmG_UICacheIList), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCUseProxy', IntToStr (opmG_UseProxy), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCProxyApply', IntToStr (opmG_ProxyApply), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCStorePass', IntToStr (opmG_DBStorePass), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCSilent', IntToStr (opmG_UISilent), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCConfirmDels', IntToStr (opmG_UIConfirmDels), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCConfirmDrag', IntToStr (opmG_UIConfirmDrag), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCConfirmMods', IntToStr (opmG_UIConfirmMods), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAllowZeroPrice', IntToStr (opmG_UIAllowZeroPrice), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAllowEditImageName', IntToStr (opmG_UIAllowEditImageName), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAllowNegativeQuantity', IntToStr (opmG_UIAllowNegativeQuantity), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCAutoDownImg', IntToStr (opmG_UIAutoDownImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('UIFontName', opmG_UIFontName, opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('UIFontHeight', INTTOSTR (opmG_UIFontHeight), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('UIFontCharset', INTTOSTR (opmG_UIFontCharset), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('Clip_ColSize', IntToStr (opmG_PRNDirectPrint), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PRNDirectPrint', IntToStr (opmG_PRNDirectPrint), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PastAvailDate', INTTOSTR (opmG_Past_PAvailDate), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PastManufacturer', INTTOSTR (opmG_Past_PManufacturer), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PastTaxClass', INTTOSTR (opmG_Past_PTaxClass), opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('PastImageDir', opmG_Past_PImageDir, opm_SaveDialog_ConfigINI.FileName, opmC_RKVisual);
      PRINI_WriteSetting ('OSCNoCacheImg', IntToStr (opmG_WBNoCacheImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCResizeImg', IntToStr (opmG_WBResizeImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCWatermarkImg', IntToStr (opmG_WBWatermarkImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCWatermarkImgBlend', IntToStr (opmG_WBWatermarkBlend), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCWatermarkImgFile', opmG_WBWatermarkFile, opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCPaddingImg', IntToStr (opmG_WBPaddingImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCKeepARImg', IntToStr (opmG_WBKeepARImg), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCConfirmExit', IntToStr (opmG_UIConfirmExit), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCCenterImage', IntToStr (opmG_UICenterImage), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCDBDebugLog', IntToStr (opmG_DBDebugLog), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCHTTPCompress', IntToStr (opmG_HTTPCompress), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCWBDebug', IntToStr (opmG_UIWBDebug), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
      PRINI_WriteSetting ('OSCRememberPosition', IntToStr (opmG_UIRememberDisplay), opm_SaveDialog_ConfigINI.FileName, opmC_RKConfig);
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigWatermarkSelectFileClick(Sender: TObject);
VAR
  OpenDialog : opmT_OpenPictureDialog;
BEGIN
  TRY
    OpenDialog := opmT_OpenPictureDialog.Create (opm_Form_Config);
    TRY
      OpenDialog.DefaultExt := opmC_Def_UploadExt;
      OpenDialog.FileName := opmC_Def_UploadFilename;
      OpenDialog.Filter := _('Image files') + '|' + opmC_Def_UploadFilter + '|' + _('All files (*.*)');
      OpenDialog.Title := _('Uploading image file...');
      IF (OpenDialog.Execute = TRUE) THEN opm_Edit_ConfigWatermarkFile.Text := OpenDialog.FileName;
    FINALLY
      OpenDialog.Free;
    END;
  EXCEPT
    opm_Edit_ConfigWatermarkFile.Text := '';
  END;
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigLoadINIClick(Sender: TObject);
begin
  opm_OpenDialog_ConfigINI.DefaultExt := opmC_Def_LoadINIExt;
  opm_OpenDialog_ConfigINI.FileName := '';
  opm_OpenDialog_ConfigINI.Filter := _('Configuration files') + ' (' + opmC_Def_LoadINIFilter + ')|' + opmC_Def_LoadINIFilter + '|' + _('All files (*.*)');
  opm_OpenDialog_ConfigINI.Title := _('Loading configuration file...');
  opm_OpenDialog_ConfigINI.InitialDir := ExtractFilePath (Application.Exename);
  IF (opm_OpenDialog_ConfigINI.Execute = TRUE) THEN
    BEGIN
      opmG_ETABase := FNopm_StrToInt (FNINI_ReadSetting ('OSCETABase', opmC_Def_ETABase, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_PDFAuthor := FNINI_ReadSetting ('OSCPDFAuthor', opmC_Def_PDFAuthor, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBUsername := FNINI_ReadSetting ('OSCUsername', opmC_Def_Username, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_DBPassword := FNINI_ReadSetting ('OSCPassword', opmC_Def_Password, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_WBImgURL := FNINI_ReadSetting ('OSCImgURL', opmC_Def_ImgURL, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_WBUploadURL := FNINI_ReadSetting ('OSCUploadURL', opmC_Def_UploadURL, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_WBProxyHost := FNopm_CleanHostName (FNINI_ReadSetting ('OSCProxyHost', opmC_Def_ProxyHost, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBProxyPort := FNopm_StrToInt (FNINI_ReadSetting ('OSCProxyPort', INTTOSTR (opmC_Def_ProxyPort), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_ModConnWait := FNopm_StrToInt (FNINI_ReadSetting ('OSCModConnWait', INTTOSTR (opmC_Def_ModConnWait), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_HTTPConnWait := FNopm_StrToInt (FNINI_ReadSetting ('OSCHTTPConnWait', INTTOSTR (opmC_Def_HTTPConnWait), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_ModConnRetries := FNopm_StrToInt (FNINI_ReadSetting ('OSCModConnRetries', INTTOSTR (opmC_Def_ModConnRetries), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_HTTPConnRetries := FNopm_StrToInt (FNINI_ReadSetting ('OSCHTTPConnRetries', INTTOSTR (opmC_Def_HTTPConnRetries), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBImgX := FNopm_StrToInt (FNINI_ReadSetting ('OSCImgX', INTTOSTR (opmC_Def_ImgX), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBImgY := FNopm_StrToInt (FNINI_ReadSetting ('OSCImgY', INTTOSTR (opmC_Def_ImgY), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBImgQ := FNopm_StrToInt (FNINI_ReadSetting ('OSCImgQ', INTTOSTR (opmC_Def_ImgQ), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBPaddingColor := FNopm_StrToInt (FNINI_ReadSetting ('OSCPaddingColor', INTTOSTR (opmC_Def_PaddingColor), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      IF (opmG_WBImgURL[LENGTH (opmG_WBImgURL)] <> '/') THEN opmG_WBImgURL := opmG_WBImgURL + '/';
      opmG_UIHotTracking := FNopm_StrToInt (FNINI_ReadSetting ('OSCHotTracking', INTTOSTR (opmC_Def_HotTracking), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIClickLoad := FNopm_StrToInt (FNINI_ReadSetting ('OSCAutoLoad', INTTOSTR (opmC_Def_AutoLoad), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIDragDrop := FNopm_StrToInt (FNINI_ReadSetting ('OSCDragDrop', INTTOSTR (opmC_Def_DragDrop), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIImgDragDrop := FNopm_StrToInt (FNINI_ReadSetting ('OSCImgDragDrop', INTTOSTR (opmC_Def_ImgDragDrop), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIToolTips := FNopm_StrToInt (FNINI_ReadSetting ('OSCToolTips', INTTOSTR (opmC_Def_ToolTips), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIStripes := FNopm_StrToInt (FNINI_ReadSetting ('OSCStripes', INTTOSTR (opmC_Def_Stripes), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UICacheIList := FNopm_StrToInt (FNINI_ReadSetting ('OSCCacheIList', INTTOSTR (opmC_Def_CacheIList), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UseProxy := FNopm_StrToInt (FNINI_ReadSetting ('OSCUseProxy', INTTOSTR (opmC_Def_UseProxy), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_ProxyApply := FNopm_StrToInt (FNINI_ReadSetting ('OSCProxyApply', INTTOSTR (opmC_Def_ProxyApply), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBStorePass := FNopm_StrToInt (FNINI_ReadSetting ('OSCStorePass', INTTOSTR (opmC_Def_StorePass), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UISilent := FNopm_StrToInt (FNINI_ReadSetting ('OSCSilent', INTTOSTR (opmC_Def_Silent), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIConfirmDels := FNopm_StrToInt (FNINI_ReadSetting ('OSCConfirmDels', INTTOSTR (opmC_Def_ConfirmDels), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIConfirmDrag := FNopm_StrToInt (FNINI_ReadSetting ('OSCConfirmDrag', INTTOSTR (opmC_Def_ConfirmDrag), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIConfirmMods := FNopm_StrToInt (FNINI_ReadSetting ('OSCConfirmMods', INTTOSTR (opmC_Def_ConfirmMods), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIAllowZeroPrice := FNopm_StrToInt (FNINI_ReadSetting ('OSCAllowZeroPrice', INTTOSTR (opmC_Def_AllowZeroPrice), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIAllowEditImageName := FNopm_StrToInt (FNINI_ReadSetting ('OSCAllowEditImageName', INTTOSTR (opmC_Def_AllowEditImageName), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIAllowNegativeQuantity := FNopm_StrToInt (FNINI_ReadSetting ('OSCAllowNegativeQuantity', INTTOSTR (opmC_Def_AllowNegativeQuantity), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIAutoDownImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCAutoDownImg', INTTOSTR (opmC_Def_AutoDownImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIFontName := FNReg_ReadSetting ('UIFontName', opmC_DefaultFont, opmC_RegistryKey, opmC_RKVisual);
      opmG_UIFontHeight := FNopm_StrToInt (FNReg_ReadSetting ('UIFontHeight', INTTOSTR (opmC_DefaultFontHeight), opmC_RegistryKey, opmC_RKVisual));
      opmG_UIFontCharset := FNopm_StrToInt (FNReg_ReadSetting ('UIFontCharset', INTTOSTR (opmC_DefaultFontCharset), opmC_RegistryKey, opmC_RKVisual));
      opmG_Clip_ColSize := FNopm_StrToInt (FNReg_ReadSetting ('Clip_ColSize', INTTOSTR (opmC_Def_Clip_ColSize), opmC_RegistryKey, opmC_RKVisual));
      opmG_PRNDirectPrint := FNopm_StrToInt (FNReg_ReadSetting ('PRNDirectPrint', INTTOSTR (opmC_Def_PRNDirectPrint), opmC_RegistryKey, opmC_RKVisual));
      opmG_Past_PAvailDate := FNopm_StrToInt (FNReg_ReadSetting ('PastAvailDate', INTTOSTR (opmC_Def_Past_PAvailDate), opmC_RegistryKey, opmC_RKVisual));
      opmG_Past_PManufacturer := FNopm_StrToInt (FNReg_ReadSetting ('PastManufacturer', INTTOSTR (opmC_Def_Past_PManufacturer), opmC_RegistryKey, opmC_RKVisual));
      opmG_Past_PTaxClass := FNopm_StrToInt (FNReg_ReadSetting ('PastTaxClass', INTTOSTR (opmC_Def_Past_PTaxClass), opmC_RegistryKey, opmC_RKVisual));
      opmG_Past_PImageDir := FNReg_ReadSetting ('PastImageDir', opmC_Def_Past_PImageDir, opmC_RegistryKey, opmC_RKVisual);
      opmG_WBNoCacheImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCNoCacheImg', INTTOSTR (opmC_Def_NoCacheImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBResizeImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCResizeImg', INTTOSTR (opmC_Def_ResizeImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBWatermarkImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCWatermarkImg', INTTOSTR (opmC_Def_WatermarkImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBWatermarkBlend := FNopm_StrToInt (FNINI_ReadSetting ('OSCWatermarkBlend', INTTOSTR (opmC_Def_WatermarkBlend), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBWatermarkFile := FNINI_ReadSetting ('OSCWatermarkFile', opmC_Def_WatermarkFile, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      opmG_WBPaddingImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCPaddingImg', INTTOSTR (opmC_Def_PaddingImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_WBKeepARImg := FNopm_StrToInt (FNINI_ReadSetting ('OSCKeepARImg', INTTOSTR (opmC_Def_KeepARImg), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIConfirmExit := FNopm_StrToInt (FNINI_ReadSetting ('OSCConfirmExit', INTTOSTR (opmC_Def_ConfirmExit), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UICenterImage := FNopm_StrToInt (FNINI_ReadSetting ('OSCCenterImage', INTTOSTR (opmC_Def_CenterImage), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_DBDebugLog := FNopm_StrToInt (FNINI_ReadSetting ('OSCDBDebugLog', INTTOSTR (opmC_Def_DBDebugLog), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_HTTPCompress := FNopm_StrToInt (FNINI_ReadSetting ('OSCHTTPCompress', INTTOSTR (opmC_Def_HTTPCompress), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIWBDebug := FNopm_StrToInt (FNINI_ReadSetting ('OSCWBDebug', INTTOSTR (opmC_Def_WBDebug), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      opmG_UIGUILang := FNINI_ReadSetting ('OSCGUILang', opmC_Def_GUILang, opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig);
      IF (FNopm_CheckLanguage (opmG_UIGUILang) = FALSE) THEN opmG_UIGUILang := opmC_Def_GUILang;
      opmG_UIRememberDisplay := FNopm_StrToInt (FNINI_ReadSetting ('OSCRememberPosition', INTTOSTR (opmC_Def_RememberDisplay), opm_OpenDialog_ConfigINI.FileName, opmC_RKConfig));
      PRopm_VarsToControls;
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_SpinEdit_ConfigImgQChange (Sender: TObject);
begin
  opm_Label_ConfigJPEGQCategory.Caption := FNopm_QualityExplain (opm_SpinEdit_ConfigImgQ.Value);
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Config.opm_PRRefresh_ModuleList (LastIndex : INTEGER);
VAR
  ModCounter : LONGINT;
BEGIN
  opm_PRLoad_ModuleList;
  opm_ListBox_ConfigMods.Items.Clear;
  FOR ModCounter := 0 TO (opm_TotalModules - 1) DO
    opm_ListBox_ConfigMods.Items.Add (opmG_ModuleList[ModCounter].Name);
  IF ((LastIndex + 1) < opm_TotalModules) THEN
    opm_ListBox_ConfigMods.ItemIndex := LastIndex
  ELSE opm_ListBox_ConfigMods.ItemIndex := (opm_TotalModules - 1);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_ListBox_ConfigModsClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigMods.ItemIndex >= 0) THEN
    BEGIN
      opm_BitBtn_ConfigModDel.Enabled := TRUE;
      opm_BitBtn_ConfigModEdit.Enabled := TRUE;
    END
  ELSE
    BEGIN
      opm_BitBtn_ConfigModDel.Enabled := FALSE;
      opm_BitBtn_ConfigModEdit.Enabled := FALSE;
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigColSelClick(Sender: TObject);
begin
  opm_Form_ColorSel.opmG_ColorChoosed := FNopm_DecColorToColor (opmG_WBPaddingColor);
  IF (opm_Form_ColorSel.ShowModal = mrOk) THEN
    BEGIN
      opmG_WBPaddingColor := opm_Form_ColorSel.opmG_ColorChoosedDec;
      opm_Panel_ConfigColSel.Color := opm_Form_ColorSel.opmG_ColorChoosed;
      opm_Panel_ConfigColSel.Caption := FNopm_ColorToRGB (opm_Panel_ConfigColSel.Color);
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigProxyIEClick(Sender: TObject);
VAR
  PHost : STRING;
  PPort : LONGINT;
begin
  PRopm_GetIEProxyData (PHost, PPort);
  IF ((PHost <> '') AND (PPort > 0)) THEN
    BEGIN
      opm_ComboBox_ConfigProxyHost.Text := PHost;
      opm_SpinEdit_ConfigProxyPort.Value := PPort;
    END
  ELSE
    FNopm_Message (_('Cannot find the proxy settings automatically.'), mtWarning, [mbOK], opmG_UISilent);
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigFontClick (Sender: TObject);
begin
  IF (opm_FontDialog_Config.Execute = TRUE) THEN
    BEGIN
      opm_Label_ConfigFontDetails.Caption := opm_FontDialog_Config.Font.Name + ', ' +
                                             INTTOSTR (ROUND ((opm_FontDialog_Config.Font.Height * -72) / opm_FontDialog_Config.Font.PixelsPerInch)) + ', ' +
                                             opmG_CharsetList [opm_FontDialog_Config.Font.Charset];
      FNopm_Message (_('The font will change until you restart the application.'), mtInformation, [mbOk], opmG_UISilent);
    END
  ELSE
    BEGIN
      opm_FontDialog_Config.Font.Name := opmG_UIFontName;
      opm_FontDialog_Config.Font.Height := opmG_UIFontHeight;
      opm_FontDialog_Config.Font.Charset := opmG_UIFontCharset;
      opm_FontDialog_Config.Font.Style := opmC_DefaultFontStyle;
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_CheckBox_ConfigUseProxyClick (Sender: TObject);
begin
  opm_ComboBox_ConfigProxyApply.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_ComboBox_ConfigProxyHost.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_SpinEdit_ConfigProxyPort.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_BitBtn_ConfigProxyIE.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Label_ConfigPHost.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
  opm_Label_ConfigPPort.Enabled := opm_CheckBox_ConfigUseProxy.Checked;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_CheckBox_ConfigWatermarkImgClick(Sender: TObject);
begin
  opm_Label_ConfigWatermarkBlend.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_SpinEdit_ConfigWatermarkBlend.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_Edit_ConfigWatermarkFile.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_BitBtn_ConfigWatermarkSelectFile.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
  opm_Label_ConfigWatermarkFile.Enabled := opm_CheckBox_ConfigWatermarkImg.Checked;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_ListBox_ConfigReportsClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigReports.ItemIndex >= 0) THEN
    BEGIN
      opm_BitBtn_ConfigReportEdit.Enabled := TRUE;
      opm_BitBtn_ConfigReportPreview.Enabled := TRUE;
    END
  ELSE
    BEGIN
      opm_BitBtn_ConfigReportEdit.Enabled := FALSE;
      opm_BitBtn_ConfigReportPreview.Enabled := FALSE;
    END;
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigReportEditClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigReports.ItemIndex >= 0) THEN
    BEGIN
      TRY
        opm_frReport_Config.LoadFromFile (ExtractFilePath (Application.Exename) + opmC_DirReports + '/' + opm_ListBox_ConfigReports.Items[opm_ListBox_ConfigReports.ItemIndex]);
        opm_frReport_Config.DesignReport;
      EXCEPT
        ON E : Exception DO
          BEGIN
            FNopm_Message (_('Error while editing report') + #13#10 + E.Message, mtError, [mbOk], opmG_UISilent);
          END;
      END;
      opm_PRRefresh_ReportList (opm_ListBox_ConfigReports.ItemIndex);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_Config.opm_PRRefresh_ReportList (LastIndex : INTEGER);
VAR
  DirRecord : TSearchRec;
  RepCount : LONGINT;
BEGIN
  RepCount := 0;
  opm_ListBox_ConfigReports.Items.Clear;
  IF (SysUtils.FINDFIRST (ExtractFilePath (Application.Exename) + opmC_DirReports + '/' + '*.' + opmC_Def_ReportExt, faAnyFile, DirRecord) = 0) THEN
    BEGIN
      REPEAT
        opm_ListBox_ConfigReports.Items.Add (TRIM (DirRecord.Name));
        INC (RepCount);
      UNTIL (SysUtils.FINDNEXT (DirRecord) <> 0);
      SysUtils.FINDCLOSE (DirRecord);
      IF (LastIndex < RepCount) THEN
        opm_ListBox_ConfigReports.ItemIndex := LastIndex
      ELSE opm_ListBox_ConfigReports.ItemIndex := (RepCount - 1);
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_frReport_ConfigGetValue (const ParName: String; var ParValue: Variant);
begin
  ParValue := _('Test data') + ' ' + INTTOSTR (opm_frUserDataset_Config.RecNo);
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_frUserDataset_ConfigCheckEOF (Sender: TObject; var Eof: Boolean);
begin
  EOF := (opm_frUserDataset_Config.RecNo > 100);
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigReportPreviewClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigReports.ItemIndex >= 0) THEN
    BEGIN
      TRY
        opm_frReport_Config.LoadFromFile (ExtractFilePath (Application.Exename) + opmC_DirReports + '/' + opm_ListBox_ConfigReports.Items[opm_ListBox_ConfigReports.ItemIndex]);
        opm_frReport_Config.ShowReport;
      EXCEPT
        ON E : Exception DO
          BEGIN
            FNopm_Message (_('Error while editing report') + #13#10 + E.Message, mtError, [mbOk], opmG_UISilent);
          END;
      END;
      opm_PRRefresh_ReportList (opm_ListBox_ConfigReports.ItemIndex);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigModEditClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigMods.ItemIndex >= 0) THEN
    BEGIN
      opm_Form_ConfigMod.MC_Name := TRIM (opm_ListBox_ConfigMods.Items[opm_ListBox_ConfigMods.ItemIndex] + '.' + opmC_Def_ModulesExt);
      opm_Form_ConfigMod.MC_AddEdit := FALSE;
      IF (opm_Form_ConfigMod.ShowModal = mrOK) THEN opm_PRRefresh_ModuleList (opm_ListBox_ConfigMods.ItemIndex);
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigModAddClick(Sender: TObject);
begin
  opm_Form_ConfigMod.MC_Name := '';
  opm_Form_ConfigMod.MC_AddEdit := TRUE;
  IF (opm_Form_ConfigMod.ShowModal = mrOK) THEN opm_PRRefresh_ModuleList (opm_ListBox_ConfigMods.ItemIndex);
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_BitBtn_ConfigModDelClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigMods.ItemIndex >= 0) THEN
    IF (FNopm_Message (_('Are you sure you want to delete this module configuration?') +
                       ' [' + opm_ListBox_ConfigMods.Items[opm_ListBox_ConfigMods.ItemIndex] + ']', mtConfirmation, [mbYes, mbNo], opmG_UISilent) = mrYes) THEN
      BEGIN
        opm_PRDelete_ModuleData (opm_ListBox_ConfigMods.Items[opm_ListBox_ConfigMods.ItemIndex] + '.' + opmC_Def_ModulesExt);
        opm_PRRefresh_ModuleList (opm_ListBox_ConfigMods.ItemIndex);
      END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_ListBox_ConfigModsDblClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigMods.ItemIndex >= 0) THEN
    BEGIN
      opm_Form_ConfigMod.MC_Name := TRIM (opm_ListBox_ConfigMods.Items[opm_ListBox_ConfigMods.ItemIndex] + '.' + opmC_Def_ModulesExt);
      opm_Form_ConfigMod.MC_AddEdit := FALSE;
      IF (opm_Form_ConfigMod.ShowModal = mrOK) THEN opm_PRRefresh_ModuleList (opm_ListBox_ConfigMods.ItemIndex);
    END;
end;




{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_Config.opm_ListBox_ConfigReportsDblClick(Sender: TObject);
begin
  IF (opm_ListBox_ConfigReports.ItemIndex >= 0) THEN
    BEGIN
      TRY
        opm_frReport_Config.LoadFromFile (ExtractFilePath (Application.Exename) + opmC_DirReports + '/' + opm_ListBox_ConfigReports.Items[opm_ListBox_ConfigReports.ItemIndex]);
        opm_frReport_Config.DesignReport;
      EXCEPT
        ON E : Exception DO
          BEGIN
            FNopm_Message (_('Error while editing report') + #13#10 + E.Message, mtError, [mbOk], opmG_UISilent);
          END;
      END;
      opm_PRRefresh_ReportList (opm_ListBox_ConfigReports.ItemIndex);
    END;
end;


end.
